#ifndef TESTADIJKSTRA_H_
#define TESTADIJKSTRA_H_
#include "listaadj/autoreferencia/Grafo.h" // @{\it vide Programa~\ref{xx}@
#include "Dijkstra.h" // @{\it vide Programa~\ref{xx}@
#include <iostream>
using std::cout;
using std::cin;
using std::endl;
using cap7_listaadj_autoreferencia::Grafo; // @{\it vide Programa~\ref{c_7.4}@
namespace cap7 {
	class TestaDijkstra	{
	public:
    static Grafo::Aresta *lerAresta ();
    static Grafo::Aresta *lerAresta (int u, int v, int p);
    static void main ();    		
	};
	Grafo::Aresta *TestaDijkstra::lerAresta () {
    cout << "Aresta:" << endl;
    cout << "  V1:"; int v1 = 0;
    cin >> v1;
    cout << "  V2:"; int v2 = 0;
    cin >> v2;
    cout << "  Peso:"; int peso = 0;
    cin >> peso;
    return new Grafo::Aresta (v1, v2, peso);
  }
	Grafo::Aresta *TestaDijkstra::lerAresta (int u, int v, int p) {
		int v1 = u, v2 = v, peso = p;
		return new Grafo::Aresta (v1, v2, peso);
	}
  void TestaDijkstra::main () {
    cout << "No. vertices:"; int nVertices = 0;
    cin >> nVertices;
    cout << "No. arestas:"; int nArestas = 0;
    cin >> nArestas;
    cout << "Raiz da ACMC:"; int raiz = 0;
    cin >> raiz;
    Grafo *grafo = new Grafo (nVertices);
    for (int i = 0; i < nArestas; i++) {
      Grafo::Aresta *a = lerAresta ();
      // @{\it Duas chamadas porque o grafo \'e n\~ao direcionado}@   
      grafo->insereAresta (a->_v1 (), a->_v2 (), a->_peso ());     
      //grafo->insereAresta (a->_v2 (), a->_v1 (), a->_peso ()); 
      delete a;
    }
    grafo->imprime ();  

    Dijkstra dj (grafo);
    dj.obterArvoreCMC (raiz);
    dj.imprime ();
    dj.imprimeCaminho (0, 2);
    delete grafo;
  }
}

#endif
